@import url('https://fonts.googleapis.com/css2?family=Space+Mono:ital,wght@0,400;0,700;1,400;1,700&display=swap');



/* variables */
:root {
    --background: linear-gradient(rgba(0,0,0,0.7)), url('/images/background.png');
    --color: #ffffff;
    --title-color: #5c5c5c;
    --button-color: #a0a0a0;
    --scrollbar: #313131;
    --panel: #1e1e1e;
    --border: #272727;
}



/* all styles */
* {
    padding: 0;
    margin: 0;
    font-family: 'Space Mono', sans-serif;
}



/* html & body */
html, body {
    width: 100%;
    height: 100%;
}



/* body */
body {
    display: flex;
    align-items: center;
    justify-content: center;
    background: var(--background);
    background-position: center;
    background-size: cover;
    color: var(--color)
}



/* wrapper */
.wrapper {
    display: flex;
    flex-direction: column;
    width: 800px;
    height: 90%;
    max-height: 90%;
    overflow-y: auto;
    background: var(--panel);
    border: 1px solid var(--border);
    outline: 5px solid var(--panel);

    &.gap > .card {
        margin-top: 2ch;
    }
}



/* header */
.header {
    display: flex;
    flex-direction: column;
    width: 100%;

    /* header - title */
    h1 {
        font-size: 1rem;
        font-weight: 600;
        padding: 1rem;
        border-bottom: dashed 1px var(--border);
        color: var(--title-color);
    }

    /* header - navigation bar */
    nav {
        display: flex;
        gap: 2ch;
        padding: 0.5rem 1rem;
        border-bottom: dashed 1px var(--border);
    }
}



/* page links */
.page-link {
    text-decoration: none;
    color: var(--color);
    font-size: 0.8rem;
    font-weight: 600;
    text-transform: uppercase;
    color: #aaaaaa;

    /* page link - hover */
    &:hover {
        color: #eeeeee;
    }   
}



/* socials */
.socials {
    display: flex;
    align-items: center;
    gap: 1.25rem;
    padding: 1rem;
    text-transform: uppercase;
    font-size: 0.8rem;
}



/* social links */
.social-link {
    display: flex;
    align-items: center;
    gap: 0.5ch;
    color: var(--color);
    text-decoration: none;
    color: #818181;

    /* social link - hover */
    &:hover {
        color: #eeeeee;
    } 
}



/* content divs */
.content {
    display: flex;
    gap: 1rem;

    /* content - table */
    table {
        border-collapse: collapse;
        table-layout: fixed ;
    }

    /* content - table columns */
    table col:nth-child(1) {
        width: 25%;
    }
    table col:nth-child(0) {
        width: 75%;
    }

    /* content - table headers */
    table th {
        padding: 0.5rem;
        text-align: left;
    }

    /* content - table rows */
    table tr {
        font-size: 0.8rem;
        border: dashed 1px var(--border);
    }

    /* content - table data */
    table td {
        vertical-align: top;
        padding: 0.5rem;
    }

    /* content - stacked elements */
    .stacked {
        display: flex;
        flex-direction: column;
    }

    /* content - stacked element paragraphs */
    .stacked p {
        font-size: 0.8rem;
        line-height: 1.6;
    }

    /* content - paragraphs after first */
    .stacked > p + p {
        margin-top: 1ch;
    }

    /* content - stacked element subtitle */
    .stacked .subtitle {
        font-size: 1rem;
        font-weight: 600;
        text-transform: uppercase;
    }

    /* content - stacked element small header */
    .stacked h3 {
        font-size: 1rem;
        font-weight: 600;
        text-transform: uppercase;
        margin-bottom: 1ch;
    }

    /* content - download button */
    .download-btn {
        display: flex;
        align-items: center;
        gap: 1ch;
        width: fit-content;
        color: var(--button-color);
        text-decoration: none;
        cursor: pointer;
        font-size: 0.8rem;
    }

    /* content - stacked element button wrapper */
    .stacked .button-wrapper {
        display: flex;
        align-items: center;
        gap: 2rem;
        margin-top: 0.5rem;
    }

    /* content - stacked element button wrapper links */
    .stacked .button-wrapper a {
        display: flex;
        align-items: center;
        gap: 1ch;
        width: fit-content;
        color: var(--button-color);
        text-decoration: none;
        cursor: pointer;
        font-size: 0.8rem;
    }

    /* content - stacked element button wrapper link hover */
    .stacked .button-wrapper a:hover { background: rgba(255, 255, 255, 0.05); }

    /* content - image */
    img {
        width: 100px;
        height: fit-content;
        border: 1px solid rgba(255, 255, 255, 0.1);
        padding: 5px;
    }

    /* content - image types */
    img.small { width: 100px; }
    img.large { width: 200px; }
    img.full {
        align-self: center;
        width: 100%;
        aspect-ratio: 3 / 1.25;
        object-fit: cover;
        object-position: center;
    }

    /* content - mod content */
    &.mod { 
        flex-direction: column;
        gap: 0.5rem;
    }

    /* content - paragraph */
    &.mod p {
        font-size: 0.8rem;
    }

    /* content - mod galleries */
    &.mod .gallery {
        display: grid;
        grid-template-columns: repeat(2, minmax(0, 1fr));
        gap: 2rem;

        /* content - gallery images */
        img {
            display: flex;
            width: 100%;
            height: 180px;
            object-fit: cover;
            padding: 0;
        }
    }
}


/* gallery */
.gallery {
    display: grid;
    grid-template-columns: repeat(2, minmax(0, 1fr));
    gap: 2rem;

    /* gallery - images */
    img {
        display: flex;
        width: 100%;
        height: 180px;
        object-fit: cover;
        padding: 0;
        animation: pop-in 0.4s cubic-bezier(0.34, 1.56, 0.64, 1) both;
    }
}



/* cards */
.card {
    display: flex;
    flex-direction: row;
    padding: 0.5rem 1rem;
    gap: 1rem;
    border-top: dashed 1px var(--border);
    border-bottom: dashed 1px var(--border);

    /* card - subtitle */
    h2 {
        font-size: 2rem;
        font-weight: 600;
        text-transform: uppercase;
    }
}



/* blogpost lists */
ol {
    display: flex;
    flex-direction: column;
    gap: 5px;
    font-size: 0.8rem;
    width: 100%;

    /* ol - article posts */
    &.articles {
        gap: 10px;
    }

    /* ol - article links */
    .article {
        display: flex;
        align-items: center;
        gap: 1rem;
        text-decoration: none;
        color: var(--color);
        border: 1px solid rgba(255, 255, 255, 0.05);
        padding: 1rem;
        opacity: 0;
        text-transform: lowercase;
        animation: pop-in 0.4s cubic-bezier(0.34, 1.56, 0.64, 1) both;
    }

    /* ol - article link icon */
    .article i {
        margin-left: auto;
    }

    /* ol - article link hover */
    .article:hover { background: rgba(255, 255, 255, 0.05); }

    /* ol - blogpost */
    .post {
        position: relative;
        display: flex;
        gap: 15px;
        padding: 0 0 0 20px;
        user-select: none;
        opacity: 0;
        text-transform: lowercase;
        animation: pop-in 0.4s cubic-bezier(0.34, 1.56, 0.64, 1) both;
        transition: padding 0.2s ease;
    }

    /* ol - blogpost colour icon */
    .post:before {
        position: absolute;
        content: '';
        left: 0;
        top: 50%;
        transform: translateY(-50%);
        width: 8px;
        border-radius: 999px;
        aspect-ratio: 1 / 1;
        background: var(--post-colour);
    }

    /* ol - blogpost type */
    .post::after {
        content: attr(data-type);
        position: absolute;
        font-size: 0.8rem;
        left: 0;
        top: 50%;
        transform: translateY(-50%);
        background: var(--post-colour);
        color: var(--color);
        padding: 2px 8px;
        opacity: 0;
        pointer-events: none;
        transition: opacity 0.2s;
        z-index: 9999;
    }

    /* ol - blogpost colour types */
    .post.website { --post-colour: #77237a; }
    .post.general { --post-colour: #6add27; }
    .post.general { --post-colour: #6add27; }
    .post.modding { --post-colour: #2a61c7; }
    .post.gaming  { --post-colour: #f5f122; }

    /* ol - project links */
    &.projects a {
        display: flex;
        align-items: center;
        gap: 1rem;
        text-decoration: none;
        text-transform: lowercase;
        color: var(--color);
        border: 1px solid rgba(255, 255, 255, 0.05);
        padding: 1rem;
    }

    /* ol - project link icons */
    &.projects a i {
        margin-left: auto;
    }

    /* ol - hover events */
    &.projects a:hover { background: rgba(255, 255, 255, 0.05); }
    .post:hover { padding-left: 80px; }
    .post:hover::after { opacity: 1; }
}


/* pop animation */
@keyframes pop-in {
    from {
        opacity: 0;
        transform: scale(0.85);
    }

    to {
        opacity: 1;
        transform: scale(1);
    }
}



/* scrollbar */
::-webkit-scrollbar {
    appearance: none;
    width: 5px;
}

::-webkit-scrollbar-thumb {
    background: var(--scrollbar);
}